﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Windows.Threading;
using System.Collections.ObjectModel;

namespace RadMenu_SL_616784
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void RadMenuItem_MouseEnter(object sender, MouseEventArgs e)
        {
            FillMethod();
        }

        private void FillMethod()
        {
            if (IsRadMenuLoaded)
            {
                this.Dispatcher.BeginInvoke( () =>
                {
                    var viewmodel = (MainPageViewModel) this.Resources["ViewModel"];
                    viewmodel.PopupCommand.Execute(null);
                });
            }
        }
        private bool IsRadMenuLoaded = false;
        private void RadMenuItem_Loaded(object sender, RoutedEventArgs e)
        {
            IsRadMenuLoaded = true;
        }


    }

    public class MainPageViewModel
    {

        public ReadOnlyObservableCollection<Group> Groups { get; set; }
        public DelegateCommand ActionCommand { get; set; }
        public DelegateCommand PopupCommand { get; set; }
        public Dispatcher UIDispatcher { get; set; }

        private DispatcherTimer timer;
        private ObservableCollection<Group> groups;

        protected virtual void InvokePopup(object obj)
        {
            // add groups async... simulates service call
            if (this.timer == null)
            {
                this.timer = new DispatcherTimer() { Interval = TimeSpan.FromMilliseconds(1500) };
                this.timer.Tick += new EventHandler(FillContextMenuMethod);
                this.timer.Start();
            }
        }

        public MainPageViewModel()
        {
            // add some items
            ActionCommand = new DelegateCommand((_) => RadWindow.Alert("Action"));
            PopupCommand = new DelegateCommand(InvokePopup);
            groups = new ObservableCollection<Group>();
            this.Groups = new ReadOnlyObservableCollection<Group>(this.groups);
            this.groups.Add(new Group { Name = "Loading...", Id = "---" });

            this.UIDispatcher = (new Border()).Dispatcher;
        }

        private void FillContextMenuMethod(object sender, EventArgs e)
        {
            this.timer.Stop();
            this.timer.Tick -= new EventHandler(FillContextMenuMethod);

            UIDispatcher.BeginInvoke(() =>
            {
                this.groups.Add(new Group { Name = "Item 1", Id = "1" });
                this.groups.Add(new Group { Name = "Item 2", Id = "2" });
                this.groups.Add(new Group { Name = "Item 3", Id = "3" });
                this.groups.RemoveAt(0);
            });
        }
    }

    public class Group
    {
        public string Name { get; set; }
        public string Id { get; set; }
    }
}
